import './index.css';
import React from 'react';
import { useLocation, matchPath } from "react-router";

import { AppData } from "../../context/data"

export default function Game() {
  const [data] = React.useContext(AppData)

const { pathname } = useLocation();
const isProposalPath = matchPath("/game/proposal/*", pathname);
const isActivelPath = matchPath("/game/active/*", pathname);
const isArchivePath = matchPath("/game/archive/*", pathname);

console.log("path: Proposal ", isProposalPath != null, "Active", isActivelPath != null, "Archive", isArchivePath != null )

  if (!data?.games)
    return <div>Loading..</div>

  // for (const [key, value] of Object.entries(data.games))
  //   console.log(key, value);
   
  const waitForYou = data.games
    .filter(game => game.status === Status.WaitForYou)
    .map(game => { 
      return <div className="li" key={game.uuid}>
        <p>
          You {Stone(game.myColor)} <i>vs</i> {game.opponentName} {Stone(oppositeColor(game.myColor))}
          <br/>
          <q>{game.message}</q>
          <br/>
          {/* <Accept uuid={game.uuid}/>
          <Reject uuid={game.uuid}/> */}
        </p>
        </div>
    });

  const WaitForOpponent = data.games
    .filter(game => game.status === Status.WaitForOpponent)
    .map(game => { 
      return <div className="li" key={game.uuid}>
        <p> 
          You {Stone(game.myColor)} <i>vs</i> {game.opponentName} {Stone(oppositeColor(game.myColor))}
          <br/>
          <q>{game.message}</q>
          <br/>
          {/* <Cancel uuid={game.uuid}/> */}
        </p>
        </div>
    });

  return <div className="Container">
    <div className="Games">
      {waitForYou}
      {WaitForOpponent.length > 0 && 
        <div className="separator">
          waiting for opponent ({WaitForOpponent.length})
        </div>
      }
      {WaitForOpponent}
    </div>
    </div>
};


const Status = {
	WaitForOpponent: "GAME_PROPOSAL_WAIT_FOR_OPPONENT",
	WaitForYou:      "GAME_PROPOSAL_WAIT_FOR_YOU",
}

function Stone(color) {
  if (color === "WHITE")
    return <span className="stone">⛀</span>

  if (color === "BLACK")
    return <span className="stone">⛂</span>

  return <span className="stone">{color}</span>
}

function oppositeColor(color) {
  if (color === "WHITE")
    return "BLACK"

  if (color === "BLACK")
    return "WHITE"

  return color
}
